%%Kriteriální funkce korelace pro alg.světlušky
function CC = kritCCfire(vstup1,vstup2,obraz1,obraz2)                       %funkce, do které vstupují posuny v osách a obrazy
A=obraz1;                                                                   %přeuložení do proměnné
B=obraz2;                                                                   %přeuložení do proměnné
c = [400 400 100 100];                                                      %volba hraničních sloupců vymezujících oblast zájmu
r = [180 400 400 180];                                                      %volba hraničních řádků vymezujících oblast zájmu
maskaA=roipoly(A,c,r);                                                      %vytvoření masky
for f=1:length(vstup1)                                                      %pro dané posuny
x=vstup1(f);                                                                %výběr posunu v ose x   
y=vstup2(f);                                                                %výběr posunu v ose y
c2 = [400+x 400+x 100+x 100+x];                                             %realizace posunu pomocí masky, posunuté sloupce      
r2 = [180+y 400+y 400+y 180+y];                                             %realizace posunu pomocí masky, posunuté řádky
maskaB=roipoly(B,c2,r2);                                                    %vytvoření nové oblasti zájmu
AA=A(maskaA>0);                                                             %výběr prvků v oblasti zájmu  
BB=B(maskaB>0);                                                             %výběr prvků v oblasti zájmu       
AA=AA-mean(mean(AA));                                                       %výpočet hodnoty pro kosinové kritérium
BB=BB-mean(mean(BB));                                                       %výpočet hodnoty pro kosinové kritérium
CC(f) = sum(sum(AA.*BB))/sqrt(sum(sum(AA.^2))*sum(sum(BB.^2)));             %výpočet kosinového kritéria
CC(f) = CC(f)*100;                                                          %normalizace
CC(f)=-CC(f);                                                               %úprava pro hledání minuma
end
